(function () {
    jQuery.ajax({
        url: 'https://api_secure_prod.millioneyez.com/v1.0/curator/getPendingFeedCount?authorization=Bearer+' + millioneyez.token + '&version=2.1.6',
        type: 'GET',
        success: function (data) {
            if (data.pendingFeedCount > 0) {
                updateData(data.pendingFeedCount);
            }
        }
    });

    var socket = io('https://api_secure_prod.millioneyez.com');
    var lastUpdate;
    socket.on('currentTime', function (currentTimeFromServer) {
        if (!lastUpdate) {
            lastUpdate = currentTimeFromServer;
        }
    });
    socket.on('update', function() {
        jQuery.ajax({
            url: 'https://api_secure_prod.millioneyez.com/v1.0/curator/getPendingFeedCount?authorization=Bearer+' + millioneyez.token + "&lastUpdate=" + lastUpdate + "&version=2.1.6",
            type: 'GET',
            success: function (data) {
                if (data) {
                    lastUpdate = data.lastUpdatedTime || lastUpdate;
                    if (data.pendingFeedCount != undefined) {
                        updateData(data.pendingFeedCount);
                    }
                    if (data.photoboxes) {
                        updateEditor(data.photoboxes);
                    }
                }
            }
        });
    });
})()

function updateData(data) {
    jQuery(".me-counter-badge").removeClass("count-0").addClass("count-"+data);
    jQuery(".me-counter-badge").find("span.update-count").text(data);
}

function updateEditor(data) {
    var documentContent = content_ifr.contentDocument ? jQuery(content_ifr.contentDocument) : jQuery(content_ifr.document);
    for(var photobox of data) {
        var editor = jQuery(documentContent.find('img[data-millioneyez-shortcode="' + photobox.id+'"]'));
        if (editor) {
            editor.parent().find('.mePendingBadge').text(photobox.pending);

        }
    }
}